// Bezeichnung: Panel mit Rahmen
// Autor      : Andreas Brotzmann, Peter Weigel

import java.io.*;
import java.awt.*;
import java.awt.event.*;

class BorderPanel extends Panel {
  protected int is = 10; // Insets

	public BorderPanel() {
		super();
  }

	public BorderPanel(LayoutManager mgr) {
		super(mgr);
	}

	public Insets getInsets() {
		return new Insets(is,is,is,is);
	}

	public void setInsets(int is) {
		this.is = is;
	}

	public void paint(Graphics g){
		super.paint(g);
    Dimension d = this.getSize();

		g.setColor(getBackground().brighter());
		g.drawLine(0, 0, d.width-1, 0);
		g.drawLine(0, 0, 0, d.height-1);

		g.setColor(getBackground().darker());
		g.drawLine(0, d.height-1, d.width-1, d.height-1);
		g.drawLine(d.width-1, 0, d.width-1, d.height-1);
	}
}
