// Peter Weigel

// doubleele    (class)
// doublefield  (class)

package pefas.field;

class doubleele extends element {
  protected double value;                           // das eigentliche Element

  public doubleele(double value) {                    // Konstruktor
    this.value = value;                           // Integer-Wert bernehmen
  }

  public double value() {                           // Wert ermitteln
    return value;
  }

  public boolean lessthan(ielement ele) {          // Implementierung der abstrakten Methode
    return (this.value() < ((doubleele) ele).value());
  }

  public boolean equal(ielement ele) {             // Implementierung der abstrakten Methode
    return (this.value() == ((doubleele) ele).value());
  }

  public String toString() {                       // Implementierung der abstrakten Methode
    return Double.toString(value());
  }
}

public final class doublefield extends field implements idoublefield {

  public doublefield(int n) {                  // Der Konstruktor bleibt der selbe
    super(n);
  }

  public void value(int i, double value) {     // Wert setzen
    item(i, new doubleele(value));             // Element erzeugen und weiterreichen.
  }

  public double value(int i) {                 // Wert ermitteln
    return ((doubleele) item(i)).value();      // Element holen und explizit als intele casten.
  }

  public void append(double value) {           // Feld vergrern und neuen Wert am Ende einfgen
    append(new doubleele(value));              // Element erzeugen und weiterreichen.
  }
}
