// Peter Weigel

// ifield (interface)

/*
  +-----------------------------------------------------------------------------------------+
  | Interface-Deklaration eines beliebigen unspezialisierten Feldes.                        |
  +------------+----------------------------------------------------------------------------+
  | name       | ifield                                                                     |
  | extends    |                                                                            |
  | implements |                                                                            |
  | type       | interface                                                                  |
  +------------+----------------------------------------------------------------------------+
  | public int     length();                 // reale Feldlnge ermitteln                   |
  | public boolean lt(int i, int j);         // Vergleich zweier Elemente auf echt kleiner  |
  | public boolean gt(int i, int j);         // Vergleich zweier Elemente auf echt grer   |
  | public boolean eq(int i, int j);         // Vergleich zweier Elemente Gleichheit        |
  | public void    exchange(int i, int j);   // Austausch zweier Elemente                   |
  | public void    move(int i, int j);       // Verschieben eines Elementes                 |
  | public String  toString();               // Listeninhalt ausgeben                       |
  +-----------------------------------------------------------------------------------------+
*/

package pefas.field;

public interface ifield {
  public int length();                     // Reale Feldlnge ermitteln
  public boolean lt(int i, int j);         // Vergleich zweier Elemente auf echt kleiner
  public boolean gt(int i, int j);         // Vergleich zweier Elemente auf echt grer
  public boolean eq(int i, int j);         // Vergleich zweier Elemente Gleichheit
  public void exchange(int i, int j);      // Austausch zweier Elemente
  public void move(int i, int j);          // Verschieben eines Elementes
  public String toString();                // Listeninhalt ausgeben
}

// Denkbar wre eine Implementierung als unspezialisiertes Feld, spezialisiertes Feld
// oder als Liste. Auf jeden Fall mu das Interface noch erweitert werden.

