// Peter Weigel

// Partitsort
// Variante 1

package pefas.sort;

import pefas.field.*;

public class partitsort1 extends sort {

  public void sort(ifield A, int l, int r) {
    for (int i=0; i<((r-l+1)/2); i++) {
      int q = partition(A, l+i, r-i, 0);
      partition(A, l+i, q  , 1);
      partition(A, q+1, r-i, 2);
    }
  }

  protected int partition(ifield A, int l, int r, int k) {
    if (l < r) {
      int q = (r-l+1)/2;
      for (int i=l+q; i<=r; i++) {
        if (A.gt(i-q, i)) {
          A.exchange(i-q, i);
        }
      }
      if      (k==0) { return r-q; }
      else if (k==1) { partition(A, l    , r-q, k); }
      else if (k==2) { partition(A, r-q+1, r  , k); }
    }
    return -1;
  }

}

