// Bezeichnung: Applet
// Autor      : Peter Weigel

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class vasaapplet extends Applet implements ActionListener {
  protected vasa win        = null; 
  protected boolean button  = true;

  public void init() {
    String s = getParameter("button");
    if ((s != null) && (!s.equals(""))) {
      button = true;
      BorderLayout bl = new BorderLayout();
      Button b = new Button(s);
      setLayout(bl);
      add(b, BorderLayout.CENTER);
      b.addActionListener(this);
    } else {
      button = false;
    }

  }

  public void start() {
    if ((button == false) && (win == null)) {
      win = new vasa(true, false);
    }
  }

  public void actionPerformed(ActionEvent evt) {
    if (win != null) {
      win.setVisible(true);
    } else {
      win = new vasa(true, true);
    }
  }

  public void stop() {
    if (win != null) {
      win.exit();
      win.dispose();
      win = null;
    }
    System.gc();
  }

  public String getAppletInfo() {
    return "Title   : "+vasa.title()+"\nVersion: "+vasa.version()+"\nAutor   : "+vasa.autor()+"\n";
  }

  public String[][] getParameterInfo() {
    String[][] info = {{"button", "Applet starten", "Text fr Startbutton. Leerstring bedeutet direkter Start."}};
    return info;
  }

}
