// Bezeichnung: Label als Zeitanzeige
// Autor      : Peter Weigel, Andreas Brotzmann

import java.awt.*;

class TimeLabel extends Label implements Runnable {
	protected Thread TimeThread;
  protected boolean TimeFlag;
	protected final int DELAY = 100;
  protected String ClearText;

	public TimeLabel(String Text, Color Foreground, Font f){
		super("TimeLabel");
    setForeground(Foreground);
    setFont(f);
    ClearText = Text;
    clear();
    TimeThread = null;
		}

	public void run(){
		long starttime = System.currentTimeMillis();
    while (TimeFlag == true) {
      setTime(System.currentTimeMillis() - starttime);
      try {
        Thread.sleep(DELAY);
      } catch (InterruptedException e) {};
    }
    clear();
	}

	public void start() {
    if (TimeFlag == true) { stop(); }
		setTime(0);TimeFlag = true;
		TimeThread = new Thread(this);
		TimeThread.start();
		}

	public void stop() {
    TimeFlag = false;
    if (TimeThread != null) {
      try {
        TimeThread.join();
      } catch (InterruptedException e) {};
      TimeThread = null;
    }
	}

	protected void clear() {
    setText(ClearText);
  }

	public void setTime(long millis){
    millis /= 100;
    String s = Float.toString(((float) millis)/10);
    setText(s+" s");
	}
}
