// Peter Weigel

// byteele    (class)
// bytefield  (class)

package pefas.field;

class byteele extends element {
  protected byte value;                           // das eigentliche Element

  public byteele(byte value) {                    // Konstruktor
    this.value = value;                           // Integer-Wert bernehmen
  }

  public byte value() {                           // Wert ermitteln
    return value;
  }

  public boolean lessthan(ielement ele) {          // Implementierung der abstrakten Methode
    return (this.value() < ((byteele) ele).value());
  }

  public boolean equal(ielement ele) {             // Implementierung der abstrakten Methode
    return (this.value() == ((byteele) ele).value());
  }

  public String toString() {                       // Implementierung der abstrakten Methode
    return Byte.toString(value());
  }
}

public final class bytefield extends field implements ibytefield {

  public bytefield(int n) {                  // Der Konstruktor bleibt der selbe
    super(n);
  }

  public void value(int i, byte value) {     // Wert setzen
    item(i, new byteele(value));             // Element erzeugen und weiterreichen.
  }

  public byte value(int i) {                 // Wert ermitteln
    return ((byteele) item(i)).value();      // Element holen und explizit als intele casten.
  }

  public void append(byte value) {           // Feld vergrern und neuen Wert am Ende einfgen
    append(new byteele(value));              // Element erzeugen und weiterreichen.
  }
}
