// Peter Weigel

// iintfield (inteface)

/*
  +-----------------------------------------------------------------------------------------+
  | Interface-Deklaration eines speziellen Feldes.                                          |
  +------------+----------------------------------------------------------------------------+
  | name       | iintfield                                                                  |
  | extends    | ifield                                                                     |
  | implements |                                                                            |
  | type       | interface                                                                  |
  +------------+----------------------------------------------------------------------------+
  | public int     length();                 //                                             |
  | public boolean lt(int i, int j);         //                                             |
  | public boolean gt(int i, int j);         //                                             |
  | public boolean eq(int i, int j);         //                                             |
  | public void    exchange(int i, int j);   //                                             |
  | public void    move(int i, int j);       //                                             |
  | public void    value(int i, int value);  // Wert setzen                                 |
  | public int     value(int i);             // Wert ermitteln                              |
  | public String  toString();               //                                             |
  +-----------------------------------------------------------------------------------------+
*/

package pefas.field;

public interface iintfield extends ifield {
  public void value(int i, int value);      // Wert setzen
  public int  value(int i);                 // Wert ermitteln
}
