// Peter Weigel

// shortele    (class)
// shortfield  (class)

package pefas.field;

class shortele extends element {
  protected short value;                           // das eigentliche Element

  public shortele(short value) {                    // Konstruktor
    this.value = value;                           // Integer-Wert bernehmen
  }

  public short value() {                           // Wert ermitteln
    return value;
  }

  public boolean lessthan(ielement ele) {          // Implementierung der abstrakten Methode
    return (this.value() < ((shortele) ele).value());
  }

  public boolean equal(ielement ele) {             // Implementierung der abstrakten Methode
    return (this.value() == ((shortele) ele).value());
  }

  public String toString() {                       // Implementierung der abstrakten Methode
    return Short.toString(value());
  }
}

public final class shortfield extends field implements ishortfield {

  public shortfield(int n) {                  // Der Konstruktor bleibt der selbe
    super(n);
  }

  public void value(int i, short value) {     // Wert setzen
    item(i, new shortele(value));             // Element erzeugen und weiterreichen.
  }

  public short value(int i) {                 // Wert ermitteln
    return ((shortele) item(i)).value();      // Element holen und explizit als intele casten.
  }

  public void append(short value) {           // Feld vergrern und neuen Wert am Ende einfgen
    append(new shortele(value));              // Element erzeugen und weiterreichen.
  }
}
