// Peter Weigel

// isort (interface)

/*
  +-----------------------------------------------------------------------------------------+
  | Interface-Deklaration eines beliebigen allgemeines Sortierverfahrens.                   |
  +------------+----------------------------------------------------------------------------+
  | name       | isort                                                                      |
  | extends    |                                                                            |
  | implements |                                                                            |
  | type       | interface                                                                  |
  +------------+----------------------------------------------------------------------------+
  | public void    sort(ifield A, int l, int r); // Sortieren eines Teilfeldes              |
  | public void    sort(ifield A);               // Sortieren des gesamten Feldes           |
  +-----------------------------------------------------------------------------------------+
*/

package pefas.sort;

import  pefas.field.ifield;

public interface isort {
  public void sort(ifield A, int l, int r);     // Sortieren eines Teilfeldes
  public void sort(ifield A);                   // Sortieren des gesamten Feldes
}

// Denkbar wre eine Implementierung als normales Objekt oder als Thread.
