// Peter Weigel

// Shakersort
// Variante 3

package pefas.sort;

import pefas.field.ifield;

public class shakersort3 extends sort{

  public void sort(ifield A, int l, int r) {          //Sortieren eines Teilfeldes
    int q;
    while (l < r) {
      q = split(A, l, r);
      shaker1(A, q+1, r);r--;
      shaker2(A, l  , q);l++;
    }
  }

  protected int split(ifield A, int l, int r) {
    int q = (r-l+1)/2;
    for (int i= l+q; i<=r; i++) {
      if (A.gt(i-q, i)) {
        A.exchange(i-q, i);
      }
    }
    return r-q;
  }

  protected void shaker1(ifield A, int l, int r) {
    for(int i=l; i<r;i++) {
      if (A.gt(i, i+1)) {
        A.exchange(i, i+1);
      }
    }
  }

  protected void shaker2(ifield A, int l, int r) {
    for(int i=r; i>l;i--) {
      if (A.lt(i, i-1)) {
        A.exchange(i, i-1);
      }
    }
  }

}
