// Peter Weigel

// Shearsort
// Variante 2

package pefas.sort;

import pefas.field.ifield;

public class shearsort2 extends sort {

  public void sort(ifield A, int l, int r) {
    int rows = (int) Math.sqrt(r-l+1);
    for (;((((r-l+1) % rows) != 0) && (rows>1)); rows--);
    int cols = (r-l+1)/rows;

    for (int k= (int) Math.ceil(Math.log(rows)/Math.log(2)); k>=1; k--) {
      for (int i=l; i<=r; i+=cols) {
        oetsort(A, i, i+cols-1, cols, 1, ((i-l)/cols%2==0));
      }
      for (int i=l; i<l+cols; i++) {
        oetsort(A, i, r-l-cols+i+1, rows, cols, true);
      }
    }
    for (int i=l; i<=r; i+=cols) {
      oetsort(A, i, i+cols-1, cols, 1, true);
    }
  }

  protected void oetsort(ifield A, int l, int r, int n, int gap, boolean asc) {
    for (int i = 1; i<=n; i++) {
      oet(A, l+(i%2)*gap, r, gap, asc);
    }
  }

  protected void oet(ifield A, int l, int r, int gap, boolean asc) {
    for (int i=l; i+gap<=r; i += 2*gap) {
      if (A.gt(i, i+gap) == asc) {
        A.exchange(i, i+gap);
      }
    }
  }
}
