// Peter Weigel

// Shellsort
// Variante 3

package pefas.sort;

import pefas.field.ifield;

public class shellsort2 extends sort {

  public void sort(ifield A, int l, int r) {
    int step = r-l;
    do {
      step = (int)Math.ceil((float)step/2);
      for (int i=0;i<step;i++) {
        insertsort(A, l+i, r, step);
      }
    } while (step > 1);
  }

  protected void insertsort(ifield A, int l, int r, int step) {
    for (int i=l+step; i<=r; i+=step) {
      int j= i;
      while ((j>l) && (A.gt(j-step, j))) {
        A.exchange(j-step, j);
        j -= step;
      }
    }
  }
}
